(function () {
    "use strict";

    angular.module('pos').controller('produtoGerenteDetailController', controller);
    controller.$inject = ['$scope', '$state', '$stateParams', '$window', 'produtoService'];

    function controller($scope, $state, $stateParams, $window, produtoService) {
        $scope.$parent.initializeLayout('Produto');

        //[Inicializa objetos]
        $scope.state = {
            data: { Codigo: decodeURIComponent($stateParams.id) },
            carregando: false,
            vazio: false,
            filtro: { codigo: $stateParams.id, filial: $stateParams.filial, transito: $stateParams.transito }
        };
        $scope.vendasAno = {
            data: [],
            carregando: true,
            vazio: false,
            count: 0,

        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };
        $scope.historyBack = function () {
            $window.history.back();
        }
        $scope.get = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            produtoService
                .getEstoqueGerente($scope.state.filtro)
                .then(
                    function (response) {
                        if (response.Status < 0)
                            $scope.$parent.toastr.error(response.Message, 'Serviço');
                        else
                            $scope.state.data = response.Data;

                        $scope.state.carregando = false;
                        $scope.state.vazio = ($scope.state.data == 0);
                    },
                    function (err) { $scope.$parent.toastr.error(err); }
                );
        };

        $scope.refresh = function () {
            $scope.get();
        };

        $scope.getQuantidadeCorTamanho = function (tamanhos) {
            var total = 0;

            for (var i = 0; i < tamanhos.length; i++) {
                total += tamanhos[i].Quantidade;
            }

            return total;
        }

        $scope.getQuantidadeCorTamanho = function (size) {
            var total = 0;
            if (!size || size == "")
                return 0;

            if ($scope.state.data.Estoques == null)
                $scope.state.data.Estoques = [];

            for (var i = 0; i < $scope.state.data.Estoques.length; i++) {
                var item = $scope.state.data.Estoques[i];
                total += getQuantidadeTamanho(item.EstoqueTamanhos, size);
            }

            return total;
        }

        var getQuantidadeTamanho = function (array, size) {
            var total = 0;

            if (array == null)
                array = [];

            for (var i = 0; i < array.length; i++)
                if (array[i].Tamanho.Posicao == size)
                    total += array[i].Quantidade;

            return total;
        }


        $scope.getQuantidadeTotal = function () {
            var total = 0;
            if ($scope.state.data.Estoques == null)
                return total;

            for (var i = 0; i < $scope.state.data.Estoques.length; i++) {
                var item = $scope.state.data.Estoques[i];
                total += getQuantidadeTodosTamanho(item.EstoqueTamanhos);
            }
            return total;
        }
        var getQuantidadeTodosTamanho = function (array) {
            var total = 0;
            if (array == null)
                array = [];
            for (var i = 0; i < array.length; i++)
                total += array[i].Quantidade;
            return total;
        }

        $scope.GetTotalTransito = function (tamanhos) {
            var qnt = 0;

            for (var i = 0; i < tamanhos.length; i++) {
                qnt += tamanhos[i].Quantidade;
            }

            return qnt;
        }

        /*Inicializa funções*/
        $scope.initialize();
    }

})();